import { permissionBits } from "../../../../utils/permissions.js";

export default {
    path: "/api/users(/*)?",
    requiresLogin: true,
    permissions: permissionBits.ADMIN,
    type: "post",
    async execute(request, response) {
        const username = request.originalUrl.split("/")[3];
        const operation = request.originalUrl.split("/")[4];
        const args = request.body;
        switch (operation) {
            case "create":
                if (
                    await global.database.users.findOne({
                        where: { username: username },
                    })
                ) return response.redirect("/dashboard/users/create?error=User already exists");
                console.log(`Creating user ${username}`);

                let permissions = Number(args.permissions);
                if (isNaN(permissions)) {
                    permissions = 0;
                    for (const permissionBit of args.permissions) {
                        permissions += Number(permissionBit);
                    }
                }
                if(!(permissions & permissionBits.DEFAULT)) permissions ^= permissionBits.DEFAULT;
                await global.database.users.create({
                    username: username,
                    password: args.password,
                    permissions: permissions,
                });
                break;
            case "delete":
                break;
        }
    },
};
